; Compiled with: PIC10 Simulator IDE - Registered Copy v2.22
; Microcontroller model: PIC10F200
; Clock frequency: 4.0MHz
;
	R0L EQU 0x010
	R4L EQU 0x018
	R4H EQU 0x019
	R4HL EQU 0x018
	RTRIS6 EQU 0x011
	ROPTION EQU 0x012
;       The value of 'edge_zero' (global) is 15
;       The value of 'gate_on_time' (global) is 20
;       The value of 'max_count' (global) is 75
;       The value of 'count_cycle' (global) is 70
;       The value of 'touch_first' (global) is 38
;       The value of 'touch_second' (global) is 40
;       The address of 'zero_cross' (byte) (global) is 0x013
;       The address of 'touch_on' (byte) (global) is 0x015
;       The address of 'touch_off' (byte) (global) is 0x01A
;       The address of 'power_on' (byte) (global) is 0x014
;       The address of 'power_off' (byte) (global) is 0x01B
;       The address of 'min_power' (byte) (global) is 0x01C
;       The address of 'counter_decisecond' (byte) (global) is 0x01D
;       The address of 'counter_second' (byte) (global) is 0x01E
;       The address of 'counter_minute' (byte) (global) is 0x017
;       The address of 'timer_volume' (byte) (global) is 0x016
;       The address of 'gate_out' (bit) (global) is 0x006,0
;       The address of 'zero_input' (bit) (global) is 0x006,1
;       The address of 'sens_input' (bit) (global) is 0x006,2
;       The address of 'mode_in' (bit) (global) is 0x006,3
	ORG 0x0000
	MOVWF OSCCAL
	CLRF FSR
	MOVLW 0xFF
	MOVWF RTRIS6
	MOVWF ROPTION
	BCF STATUS,6
	BCF STATUS,5
	GOTO L0003
_bootL0002:
	GOTO L0002
_bootDL01:
	GOTO DL01
; User code start
L0003:
; 1: Define CONFIG = 0x0009  'GP3 as input  3  
; 2: 
; 3: Symbol gate_out = GP0  '  
; 4: Symbol zero_input = GP1  '  
; 5: Symbol sens_input = GP2  ' ,   
; 6: Symbol mode_in = GP3  '    '   
; 7: 
; 8: ':
; 9: 
; 10: Dim zero_cross As Byte  '   
; 11: Dim touch_on As Byte  ' 
; 12: Dim touch_off As Byte  '  
; 13: Dim power_on As Byte  '  
; 14: Dim power_off As Byte  '  
; 15: Dim min_power As Byte  ' 
; 16: Dim counter_decisecond As Byte  '   
; 17: Dim counter_second As Byte  ' 
; 18: Dim counter_minute As Byte  ' 
; 19: Dim timer_volume As Byte  '   
; 20: 
; 21: Const edge_zero = 15  '  
; 22: Const gate_on_time = 20  '  
; 23: Const max_count = 75  '   
; 24: Const count_cycle = 70  '  ,     
; 25: Const touch_first = 38  '  ,     
; 26: Const touch_second = 40  '  ,       
; 27: 
; 28: '/**********   *************/
; 29: TRISIO = %1110  '  1     
	MOVLW 0x0E
	MOVWF RTRIS6
	TRIS 6
; 30: OPTION_REG = %11010110  'Prescaler Rate 1:128 assigned to Timer0 '      1  128,       0,01   78
	MOVLW 0xD6
	MOVWF ROPTION
	OPTION
; 31: 'Prescaler Rate 1:128  => 1 000 000 : 100 : 128 = Max count TMR0 = 78
; 32: 
; 33: gate_out = 0  ' 
	BCF GPIO,0
; 34: 
; 35: '/*****    *****/
; 36: '/   mode_in ,     (    ,  '   /
; 37: 
; 38: min_power = 1
	MOVLW 0x01
	MOVWF 0x01C
; 39: If mode_in = 1 Then min_power = 50  '   
	BTFSS 0x006,3
	GOTO L0004
	MOVLW 0x32
	MOVWF 0x01C
L0004:
; 40: 
; 41: '/ * * * * * * * * * * * * * * * * * * * * * * * /
; 42: 
; 43: '/**********   *************/
; 44: start:
L0001:
; 45: 
; 46: '/**********    0  1 *************/
; 47: zero_cross = edge_zero
	MOVLW 0x0F
	MOVWF 0x013
; 48: While zero_cross > 0
L0005:
	CLRF R0L
	MOVF 0x013,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0006
; 49: If zero_input = 1 Then zero_cross = zero_cross  '1
	BTFSS 0x006,1
	GOTO L0007
L0007:
; 50: Wend
	GOTO L0005
L0006:
; 51: 
; 52: Call work_mode()  '/**********   *************/
	CALL _bootL0002
; 53: 
; 54: '/**********    1  0 *************/
; 55: zero_cross = edge_zero
	MOVLW 0x0F
	MOVWF 0x013
; 56: While zero_cross > 0
L0008:
	CLRF R0L
	MOVF 0x013,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0009
; 57: If zero_input = 0 Then zero_cross = zero_cross  '1
	BTFSC 0x006,1
	GOTO L0010
L0010:
; 58: Wend
	GOTO L0008
L0009:
; 59: 
; 60: Call work_mode()  '/**********   *************/
	CALL _bootL0002
; 61: 
; 62: Goto start  '/*****     ************/
	GOTO L0001
; 63: 
; 64: End  '/**********    *************/
L0011:	GOTO L0011
; 65: 
; 66: 
; 67: '/**********   *************/
; 68: 
; 69: Proc work_mode()
L0002:
; 70: 
; 71: TMR0 = 0  '   ()
	CLRF TMR0
; 72: timer_volume = 0  '  ,    
	CLRF 0x016
; 73: 
; 74: While timer_volume < max_count  '      ,  
L0012:
	MOVLW 0x4B
	SUBWF 0x016,W
	BTFSC STATUS,C
	GOTO L0013
; 75: 
; 76: While timer_volume = TMR0  ',    
L0014:
	MOVF 0x016,W
	SUBWF TMR0,W
	BTFSS STATUS,Z
	GOTO L0015
; 77: Wend
	GOTO L0014
L0015:
; 78: 
; 79: timer_volume = TMR0  '      ,     ,   
	MOVF TMR0,W
	MOVWF 0x016
; 80: 
; 81: '/********** ,   ,  ,      *************/
; 82: If power_on = 0 Then
	CLRF R0L
	MOVF 0x014,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0016
; 83: power_off = 0
	CLRF 0x01B
; 84: Else
	GOTO L0017
L0016:
; 85: power_off = power_on + 5
	MOVLW 0x05
	ADDWF 0x014,W
	MOVWF 0x01B
; 86: Endif
L0017:
; 87: '/**********    *************/
; 88: 
; 89: '/**********     *************/
; 90: If power_on < timer_volume And timer_volume < power_off Then
	MOVF 0x016,W
	SUBWF 0x014,W
	BTFSC STATUS,C
	GOTO L0018
	MOVF 0x01B,W
	SUBWF 0x016,W
	BTFSC STATUS,C
	GOTO L0018
; 91: 
; 92: High gate_out
	BSF GPIO,0
	BCF RTRIS6,0
	MOVF RTRIS6,W
	TRIS 6
; 93: WaitUs gate_on_time
	MOVLW 0x04
	MOVWF R4L
	CALL _bootDL01
; 94: Low gate_out
	BCF GPIO,0
	BCF RTRIS6,0
	MOVF RTRIS6,W
	TRIS 6
; 95: 
; 96: Endif
L0018:
; 97: '/**********    **********/
; 98: 
; 99: '/**********       ,   ***********/
; 100: 
; 101: Select Case timer_volume
; 102: 
; 103: '/**********   /  *************/
; 104: Case touch_first  'count length touch to on: 0.2-1s, to off > 1s
	MOVLW 0x26
	MOVWF R0L
	MOVF 0x016,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0019
; 105: zero_cross = GPIO And %00000110
	MOVF GPIO,W
	MOVWF R0L
	MOVLW 0x06
	ANDWF R0L,W
	MOVWF 0x013
; 106: If zero_cross = %00000010 Then touch_on = touch_on + 1
	MOVLW 0x02
	MOVWF R0L
	MOVF 0x013,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0020
	MOVLW 0x01
	ADDWF 0x015,W
	MOVWF 0x015
L0020:
; 107: If zero_cross = %00000110 Then touch_off = touch_off + 1
	MOVLW 0x06
	MOVWF R0L
	MOVF 0x013,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0021
	MOVLW 0x01
	ADDWF 0x01A,W
	MOVWF 0x01A
L0021:
; 108: '/**********    ***********/
; 109: 
; 110: '/**********     / , /  *************/
; 111: Case touch_second
	GOTO L0022
L0019:
	MOVLW 0x28
	MOVWF R0L
	MOVF 0x016,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0023
; 112: If touch_off > 20 Then
	MOVLW 0x14
	MOVWF R0L
	MOVF 0x01A,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0024
; 113: If touch_on > 50 And touch_on < 151 Then
	MOVLW 0x32
	MOVWF R0L
	MOVF 0x015,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0025
	MOVLW 0x97
	SUBWF 0x015,W
	BTFSC STATUS,C
	GOTO L0025
; 114: power_on = 0
	CLRF 0x014
; 115: Endif
L0025:
; 116: If touch_on > 10 And touch_on < 51 Then
	MOVLW 0x0A
	MOVWF R0L
	MOVF 0x015,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0026
	MOVLW 0x33
	SUBWF 0x015,W
	BTFSC STATUS,C
	GOTO L0026
; 117: power_on = min_power
	MOVF 0x01C,W
	MOVWF 0x014
; 118: Endif
L0026:
; 119: touch_off = 0
	CLRF 0x01A
; 120: touch_on = 0
	CLRF 0x015
; 121: Endif
L0024:
; 122: '/**********    **********/
; 123: 
; 124: '/**********         *************/
; 125: Case count_cycle  'count second & minute
	GOTO L0027
L0023:
	MOVLW 0x46
	MOVWF R0L
	MOVF 0x016,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0028
; 126: If power_on = 0 Then
	CLRF R0L
	MOVF 0x014,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0029
; 127: counter_decisecond = 0
	CLRF 0x01D
; 128: counter_second = 0
	CLRF 0x01E
; 129: counter_minute = 0
	CLRF 0x017
; 130: Else
	GOTO L0030
L0029:
; 131: counter_decisecond = counter_decisecond + 1
	MOVLW 0x01
	ADDWF 0x01D,W
	MOVWF 0x01D
; 132: If counter_decisecond = 250 Then
	MOVLW 0xFA
	MOVWF R0L
	MOVF 0x01D,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0031
; 133: counter_second = counter_second + 1  '2.5 second
	MOVLW 0x01
	ADDWF 0x01E,W
	MOVWF 0x01E
; 134: counter_decisecond = 0
	CLRF 0x01D
; 135: 'If counter_second = 6 Then  '15 second ' 
; 136: If counter_second = 240 Then  '10 minute ' 
	MOVLW 0xF0
	MOVWF R0L
	MOVF 0x01E,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0032
; 137: counter_minute = counter_minute + 1
	MOVLW 0x01
	ADDWF 0x017,W
	MOVWF 0x017
; 138: counter_second = 0
	CLRF 0x01E
; 139: Endif
L0032:
; 140: Endif
L0031:
; 141: If counter_minute > 3 Then power_on = min_power
	MOVLW 0x03
	MOVWF R0L
	MOVF 0x017,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0033
	MOVF 0x01C,W
	MOVWF 0x014
L0033:
; 142: If counter_minute > 5 Then power_on = 0
	MOVLW 0x05
	MOVWF R0L
	MOVF 0x017,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0034
	CLRF 0x014
L0034:
; 143: Endif
L0030:
; 144: 
; 145: '/**********     *************/
; 146: If power_on > 1 And counter_minute = 0 Then power_on = power_on
	MOVLW 0x01
	MOVWF R0L
	MOVF 0x014,W
	SUBWF R0L,W
	BTFSC STATUS,C
	GOTO L0035
	CLRF R0L
	MOVF 0x017,W
	SUBWF R0L,W
	BTFSS STATUS,Z
	GOTO L0035
L0035:
; 147: '/**********    **********/
; 148: 
; 149: Case Else
	GOTO L0036
L0028:
; 150: EndSelect
L0036:
L0027:
L0022:
; 151: 
; 152: Wend
	GOTO L0012
L0013:
; 153: '/**********            *************/
; 154: 
; 155: End Proc
	RETLW 0x00
; 156: '/**********         *************/
; End of user code
L0037:	GOTO L0037
;
;
; Delay Routine Byte
; minimal routine execution time: 10s
; routine execution time step: 3s
; maximal routine execution time: 772s
DL01:
	DECFSZ R4L,F
	GOTO DL01
	RETLW 0x00
; Delay Routine Word
; minimal routine execution time: 17s
; routine execution time step: 10s
; maximal routine execution time: 655367s
DL02:
	MOVLW 0x01
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	IORLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETLW 0x00
	GOTO DL02
;
;
; Oscillator calibration value
	ORG 0x00FF
	MOVLW 0xFE
; Configuration settings
	ORG 0x0FFF
	DW 0x0009
; End of listing
	END
